-------------------------------------------------------------------------------
-- File name : mux41.vhdl
-- Title     : 4-1 Multiplexor
-- project   : ECE 485
-- Library   : single-cycle processor
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of single-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity mux41 is
  port (D0 : in  std_logic;
        D1 : in  std_logic;
        D2 : in  std_logic;
        D3 : in  std_logic;
        S  : in  std_logic_vector(1 downto 0);
        Y  : out std_logic);
end mux41;


architecture structure of mux41 is
begin
  
  Y <= (D0 AND NOT S(1) AND NOT S(0))
       OR (D1 AND NOT S(1) AND     S(0))
       OR (D2 AND     S(1) AND NOT S(0))
       OR (D3 AND     S(1) AND     S(0));
  
end structure;
