-------------------------------------------------------------------------------
-- File name : memory.vhd
-- Title     : Memory modules
-- project   : ECE 485
-- Library   : multi-cycle processor
-- Author(s) : Ivan Castellanos
-- Purpose   : definition of multi-cycle processor
-- notes     : non-synthesizable (only for testing)
--           : also contains Wishbone interface

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.ALL;
use std.textio.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

use IEEE.std_logic_textio.all;

entity meminst512 is
port
(
   adr       : in  std_logic_vector(8 downto 0);
   memdata   : out std_logic_vector(31 downto 0)
);
end meminst512;

architecture struct of meminst512 is
begin
  process(adr) is
                    file mem_file : text open read_mode is "inst512.dat";  
                    variable l : line;
                    variable first : boolean := true;
                    variable ch : character;
                    variable index : integer :=0;
                    type ramtype is array (511 downto 0) of std_logic_vector(31 downto 0);
                    variable mem : ramtype;
  begin

    if first then
      first:=false;

      for i in 0 to 511 loop
        mem(conv_integer(i)):="00000000000000000000000000000000";
      end loop;  
      
      while not endfile(mem_file) loop
        readline(mem_file, l);
        for j in 0 to 31 loop
            read(l,ch);
            if  ('0'=ch) then
              mem(index)(31-j):= '0';
            elsif  ('1'=ch) then
              mem(index)(31-j):= '1';
            else
              report "format error on line " & integer'image(index) severity error;
            end if;
        end loop;   
        index:=index+1;
      end loop;

    else
        memdata <= mem(conv_integer(adr));
        
        write(l, now);
        write(l, string'(" (IM) - Address: "));
        write(l, adr);
        write(l, string'(", Output: "));
        write(l, mem(conv_integer(adr)));
        writeline(output, l);
    end if;

  end process;

end struct;
